using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class prescription : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)  // first time
        {
            // get visit details
            String vid = Request.QueryString["vid"];
            SqlConnection con = new SqlConnection(Database.ConnectionString);
            con.Open();
            SqlCommand cmd = new SqlCommand("GetVisitDetails", con);
            cmd.Parameters.Add("@vid", SqlDbType.Int).Value = vid;
            cmd.CommandType = CommandType.StoredProcedure;
            SqlDataReader dr = cmd.ExecuteReader();
            dr.Read();
            lblPname.Text = dr["pname"].ToString();
            lblAge.Text = dr["age"].ToString();
            lblVid.Text = vid;
            dr.Close();
            con.Close();

            DataTable dt = CreateDrugsTable();
            Session.Add("drugs", dt);
            gvDrugs.DataSource = dt;
            gvDrugs.DataBind();

        }
    }
    protected void btnAddDrug_Click(object sender, EventArgs e)
    {
        // get drugs from session
        DataTable dt = (DataTable) Session["drugs"];
        DataRow dr = dt.NewRow();
        dr[0] = ddlDrug.SelectedItem.Value;
        dr[1] = ddlDrug.SelectedItem.Text;
        dr[2] = txtDosage.Text;
        dr[3] = txtNodays.Text;
        dr[4] = txtRemarks.Text;
        dt.Rows.Add(dr);
        Session["drugs"] = dt;
        gvDrugs.DataSource = dt;
        gvDrugs.DataBind();
    }

    public DataTable CreateDrugsTable () {
        DataTable dt = new DataTable();
        dt.Columns.Add(new DataColumn("did", Type.GetType("System.String")));
        dt.Columns.Add(new DataColumn("drugname", Type.GetType("System.String")));
        dt.Columns.Add(new DataColumn("dosage", Type.GetType("System.String")));
        dt.Columns.Add(new DataColumn("nodays", Type.GetType("System.String")));
        dt.Columns.Add(new DataColumn("remarks", Type.GetType("System.String")));

        return dt;
    }


    protected void gvDrugs_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        DataTable dt = (DataTable)Session["drugs"];
        dt.Rows.RemoveAt(e.RowIndex);
        gvDrugs.DataSource = dt;
        gvDrugs.DataBind();
        Session["drugs"] = dt;
    }

    protected void gvDrugs_RowDeleted(object sender, GridViewDeletedEventArgs e)
    {
       Response.Write(e.Keys.Count);
    }
    protected void btnSave_Click(object sender, EventArgs e)
    {

        SqlConnection con = new SqlConnection(Database.ConnectionString);
        con.Open();
        SqlTransaction trans = con.BeginTransaction();
        try
        {
            SqlCommand cmd = new SqlCommand("insert into presdrugs values(@vid,@did,@dosage,@nodays,@remarks)", con);
            cmd.Transaction = trans;
            cmd.Parameters.Add("@vid", SqlDbType.Int);
            cmd.Parameters.Add("@did", SqlDbType.Int);
            cmd.Parameters.Add("@dosage", SqlDbType.VarChar, 20);
            cmd.Parameters.Add("@nodays", SqlDbType.Int);
            cmd.Parameters.Add("@remarks", SqlDbType.VarChar, 200);
            DataTable dt = (DataTable)Session["drugs"];
            foreach (DataRow dr in dt.Rows)
            {
                cmd.Parameters["@vid"].Value = lblVid.Text;
                cmd.Parameters["@did"].Value = dr["did"].ToString();
                cmd.Parameters["@dosage"].Value = dr["dosage"].ToString();
                cmd.Parameters["@nodays"].Value = dr["nodays"].ToString();
                cmd.Parameters["@remarks"].Value = dr["remarks"].ToString();
                cmd.ExecuteNonQuery();
            }
            trans.Commit();
            lblMsg.Text = "Prescription Saved Successfully!";
        }
        catch (Exception ex)
        {
            lblMsg.Text = "Error -->" + ex.Message;
            trans.Rollback();
        }
        finally
        {
           con.Close();
        }
    }
}
